

(defrule rejectQuoteRule
(quoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) =>	 
	(bind ?rejectQuote-var (new rejectQuote ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance rejectQuoteMsgProp ?rejectQuote-var static)
	(store OUTPUT ?rejectQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/merchantQ")))

(defrule reqForQuoteRule
(startProp) =>	 
	(assert (composition_itemID_prop))
	(bind ?reqForQuote-var (new reqForQuote ?itemID-var1 ?t1))
	(definstance reqForQuoteMsgProp ?reqForQuote-var static)
	(store OUTPUT ?reqForQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/merchantQ")))

(defrule composition_quoteProp_rule
(quoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) =>	 
	(assert (remindAbout (key2 ?key2-var1) (key1 ?key1-var1))))

(defrule composition_acceptQuoteProp_rule
(acceptQuoteMsgProp  (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) =>	 
	(assert (positiveDecision)))

(defrule composition_rejectQuoteProp_rule
(rejectQuoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) =>	 
	(assert (negativeDecision)))

(defrule reminderRule
(and(composition_itemPrice_prop (transID ?t1)) (composition_itemID_prop (transID ?t2)) (not (positiveDecision))(not (negativeDecision))(remindAbout  (key2 ?key2-var5) (key1 ?key1-var5)(transID ?t5)) )
=>	 
	(bind ?reminder-var (new reminder ?key1-var4 ?key2-var4 ?t4))
	(definstance reminderMsgProp ?reminder-var static)
	(store OUTPUT ?reminder-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/customerQ")))

(defrule acceptQuoteRule
(quoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) =>	 	
(bind ?cc-var(new ConditionalCommitment "customer"   "merchant"   "goods" "pay" ?t1))
	 (definstance ccom ?cc-var static)
	(bind ?acceptQuote-var (new acceptQuote ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance acceptQuoteMsgProp ?acceptQuote-var static)
	(store OUTPUT ?acceptQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/merchantQ")))

(defrule quoteRule
(reqForQuoteMsgProp  (itemID ?itemID-var1)(transID ?t1)) =>	 
	(assert (composition_itemPrice_prop))	
	(bind ?cc-var(new ConditionalCommitment "merchant"   "customer"   "pay" "goods" ?t1))
	 (definstance ccom ?cc-var static)
	(bind ?quote-var (new quote ?itemID-var1 ?itemPrice-var1 ?t1))
	(definstance quoteMsgProp ?quote-var static)
	(store OUTPUT ?quote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/customerQ")))