/*
 * Created on Jun 22, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;


import com.hp.hpl.jena.ontology.* ;
import edu.ncsu.csc.mas.ontology.exceptions.*;

/**
 * Create a commitment.
 * 
 * The effects of <code>Message</code>s are actions. This is one of the actions.
 * 
 * @author Ashok Mallya
 *
 */
public class CreateCommitment extends Action {
    
    private Commitment commitment ;
    
    /**
     * Return a fresh <code>CreateCommitment</code> object
     *
     */
    public CreateCommitment() {
    
    }
    
    /**
     * Return a fresh <code>CreateCommitment</code> object given its JENA equivalent
     * 
     * @param res An OntResource object representing the commitment that should be created
     * @throws MalformedConditionException
    */
    public CreateCommitment(OntResource res) 
    throws MalformedConditionException
    {
        this.commitment = new Commitment(res) ;
    }
    
    public String toString() {
        return new String("createCommitment(" + commitment.toString() + ") ") ;
    }

}
