/*
 * Created on Jun 22, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;

import com.hp.hpl.jena.ontology.* ;

import edu.ncsu.csc.mas.ontology.exceptions.*;


/**
 * The Negation of a condition.
 * 
 * @author Ashok Mallya
 *
 */
public class Negation {
    
    private Condition condition ;
    
    public Negation() {
        super();
    }
    
    public Negation(OntResource node) 
    throws MalformedConditionException
    {
        this.condition = new Condition(node) ;
    }
    
    public Negation(Negation n) {
        this.condition = new Condition(n.getCondition()) ;
    }

    /**
     * @return Returns the condition.
     */
    public Condition getCondition() {
        return condition;
    }
    
    /**
     * @param condition The condition to set.
     */
    public void setCondition(Condition condition) {
       this.condition = condition;
            
    }
    
    public String toString() {
        if(condition != null)
            return new String(condition.toString()) ;
        return new String("");
    }

}
