/*
 * Created on Jun 23, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;

import com.hp.hpl.jena.ontology.* ;
import com.hp.hpl.jena.rdf.model.*;


/**
 * Represents an OWL-P slot.
 * 
 * A slot can be a BooleanSlot, FLoatSlot, IntegerSlot, or a StringSlot
 * 
 * @author aumallya,pchakra
 *
 */
public class Slot {
   
    /**
     * The name of this slot
     */
    protected String name ;
    
    /**
     * The type of this slot. Can also hold the value.
     */
    protected Object type;
    
    
    public String toString() {
        if(this.name==null || this.type==null)
            return " " ;
        return new String("obj:" + this.name) ;
     
    }
    public String toJessString() {
        if(this.name==null || this.type==null)
            return " " ;
         return new String(this.name) ;
    }
    
    public String getTypeString()
    {
    	String slotString = this.toString();
    	int index=slotString.indexOf(":");
    	String retString = slotString.substring(0,index);
    	return retString;
    }
  
    
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * @return Returns the type.
	 */
	public Object getType() {
		return type;
	}
	/**
	 * @param type The type to set.
	 */
	public void setType(Object type) {
		this.type = type;
	}
    public boolean equals(Object obj) {
    	
    	Slot objSlot = (Slot) obj;
    	return (this.toString().equals(objSlot.toString()));
    	
    	
    }

}
