 
    
 // ***Attention !!! 
package edu.ncsu.csc.mas.protocols.Order.merchantTemp;

import java.io.IOException;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.Logger;

import edu.ncsu.csc.mas.utils.JMSWrapper;
import edu.ncsu.csc.mas.utils.JessWrapper;

import edu.ncsu.csc.mas.enactments.JessJ2EE.JJMessage;
import edu.ncsu.csc.mas.protocols.Order.messages.*;


public class Main {
	
	private static JessWrapper jsw;	
	private static Logger logger = null;
	
	
	
	private static  final String CUSTOMERQ = "jms/defaultcustomerQ";
	
	private static  final String MERCHANTQ = "jms/defaultmerchantQ";
	private static  final String QCFACTORY = "jms/defaultQcf";
	private static  final String INPUT = "INPUT";
	private static  final String OUTPUT = "OUTPUT";
	
	
	public static void main(String[] args) {
	
		try{
			initLogger("/opt/log/owlp/%t/merchant.log");
			
			logger.info("Logger initialized");
			logger.info("Current working directory for merchant:"+System.getProperty("user.dir"));
			
			jsw = JessWrapper.getJessWrapperInstance();
			logger.info("JessWrapper initialized");
			
			String[] queues = new String[]{ CUSTOMERQ, MERCHANTQ,};
			JMSWrapper.initJMSWrapper(QCFACTORY, queues);
			logger.info("JMSWrapper initialized");
			
			//Initialize Jess
			jsw.executeCommand("(batch commitments.clp)");
			jsw.executeCommand("(batch merchant.clp)");
			jsw.executeCommand("(batch merchantPolicies.clp)");
			logger.info("Jess rule system initialized");
			
			// Kick-off the protocol
			start st = new start(6481);
			JMSWrapper.sendTo(MERCHANTQ,st);
			logger.info("merchant agent kicked-off");
			
			while(true)
			{
				JJMessage msg = JMSWrapper.blockingReceiveFrom(MERCHANTQ);
				logger.info("merchant received:"+msg.getType());
				String type = msg.getType();
				jsw.store(INPUT, msg);
				jsw.executeCommand("(definstance " +type+ "Msg (fetch INPUT) static)");
				logger.info("merchant stored:"+msg.getType()+ "Msg to KB");
				jsw.executeCommand("(run)");				
				
				JJMessage send = (JJMessage)jsw.fetch(OUTPUT);
				if(send!=null)
				{	
					JMSWrapper.sendTo(send.getReceiverName().toUpperCase()+"Q",send);
					logger.info("merchant sending:"+send.getType()+ " to " + send.getReceiverName());
				} 
			}
			
		}catch(Exception e){
			e.printStackTrace();
			logger.info(e.getMessage());
		}
		
	}

	private static void initLogger(String filePath) throws IOException
	{
		Handler fh = new FileHandler(filePath);
		logger = Logger.getLogger("");
		logger.addHandler(fh);		
	}
	

	public Main() {
		super();
	}

}