(import edu.ncsu.csc.mas.protocols.OrderWithReminders.messages.*)
(import edu.ncsu.csc.mas.enactments.JessJ2EE.*)
(import edu.ncsu.csc.mas.protocols.OrderWithReminders.merchant.*)
(import edu.ncsu.csc.mas.utils.JMSWrapper)
(defclass startPropMsg startProp extends msg)
(defclass rejectQuote rejectQuote extends msg)
(defclass rejectQuoteMsg rejectQuote extends msg)
(defclass rejectQuoteMsgProp rejectQuote extends msg)
(defclass reqForQuote reqForQuote extends msg)
(defclass reqForQuoteMsg reqForQuote extends msg)
(defclass reqForQuoteMsgProp reqForQuote extends msg)
(defclass reminder reminder extends msg)
(defclass reminderMsg reminder extends msg)
(defclass reminderMsgProp reminder extends msg)
(defclass acceptQuote acceptQuote extends msg)
(defclass acceptQuoteMsg acceptQuote extends msg)
(defclass acceptQuoteMsgProp acceptQuote extends msg)
(defclass quote quote extends msg)
(defclass quoteMsg quote extends msg)
(defclass quoteMsgProp quote extends msg)
(deftemplate remindAbout (slot itemID)(slot itemPrice) (slot transID))
(deftemplate composition_itemID_prop (slot itemID))
(deftemplate composition_itemPrice_prop (slot itemPrice))
(deftemplate acceptQuote_Policy)
(deftemplate rejectQuote_Policy)
(deftemplate quote_Policy (slot itemPrice))
(deftemplate reqForQuote_Policy)
(deftemplate reminder_Policy)
(defclass merchantOrderWithRemindersPolicy merchantOrderWithRemindersPolicy)

(defrule rejectQuoteRule_for_merchant
(and (quoteMsgProp (itemID ?itemID-var1) (itemPrice ?itemPrice-var2) (transID ?t1)) (rejectQuoteMsg (itemPrice ?itemPrice-var2) (itemID ?itemID-var2)(transID ?t2)) (rejectQuote_Policy))
=>	 (bind ?rejectQuote-var (new rejectQuote ?itemPrice-var2 ?itemID-var2 ?t2))
	(definstance rejectQuoteMsgProp ?rejectQuote-var static))

(defrule reqForQuoteRule_for_merchant
(and (startPropMsg (transID ?t1)) (reqForQuoteMsg (itemID ?itemID-var2)(transID ?t2)) (reqForQuote_Policy))
=>	 (bind ?reqForQuote-var (new reqForQuote ?itemID-var2 ?t2))
	(definstance reqForQuoteMsgProp ?reqForQuote-var static)
	(assert (composition_itemID_prop (itemID ?itemID-var2))))

(defrule composition_quoteProp_rule
(and (quoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) (composition_itemID_prop(itemID ?itemID-var2)) (composition_itemPrice_prop(itemPrice ?itemPrice-var2)))
=>	 (assert (remindAbout (itemID ?itemID-var2) (itemPrice ?itemPrice-var2) (transID ?t1))))

(defrule composition_acceptQuoteProp_rule
(acceptQuoteMsgProp  (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) 
=>	 (assert (positiveDecision)))

(defrule composition_rejectQuoteProp_rule
(rejectQuoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) 
=>	 (assert (negativeDecision)))

(defrule reminderRule_for_merchant
(and (remindAbout (itemID ?itemID-var2) (itemPrice ?itemPrice-var2) (transID ?t1)) (not (positiveDecision)) (not (negativeDecision)) (reminder_Policy))
=>	 (bind ?reminder-var (new reminder ?itemID-var2 ?itemPrice-var2 ?t1))
	(definstance reminderMsgProp ?reminder-var static)
	(store OUTPUT ?reminder-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/customerQ")))

(defrule acceptQuoteRule_for_merchant
(and (quoteMsgProp (itemID ?itemID-var1) (itemPrice ?itemPrice-var2)(transID ?t1)) (acceptQuoteMsg (itemPrice ?itemPrice-var2) (itemID ?itemID-var2)(transID ?t2)) (acceptQuote_Policy))
=>	 (bind ?cc-var(new JJConditionalCommitment "customer"   "merchant"   "goods" "pay" ?t2))
	 (definstance ccom ?cc-var static)(bind ?acceptQuote-var (new acceptQuote ?itemID-var2 ?itemPrice-var2 ?t2))
	(definstance acceptQuoteMsgProp ?acceptQuote-var static))

(defrule quoteRule_for_merchant
(and (reqForQuoteMsgProp  (itemID ?itemID-var1)(transID ?t1)) (quote_Policy (itemPrice ?itemPrice-var1) ))
=>	 (bind ?cc-var(new JJConditionalCommitment "merchant"   "customer"   "pay" "goods" ?t1))
	 (definstance ccom ?cc-var static)(bind ?quote-var (new quote ?itemID-var1 ?itemPrice-var1 ?t1))
	(definstance quoteMsgProp ?quote-var static)
	(assert (composition_itemPrice_prop (itemPrice ?itemPrice-var1)))
	(store OUTPUT ?quote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/customerQ")))