 /*
 * Created on Jun 25, 2004
 *
 */
package edu.ncsu.csc.mas.utils;

//import com.hp.hpl.jena.rdf.model.*;
//import com.hp.hpl.jena.ontology.* ;
//import com.hp.hpl.jena.util.iterator.*;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;

import com.hp.hpl.jena.ontology.OntResource;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;

import edu.ncsu.csc.mas.ontology.Policy;
import edu.ncsu.csc.mas.ontology.Protocol;
import edu.ncsu.csc.mas.ontology.Role;
import edu.ncsu.csc.mas.ontology.Rule;
import edu.ncsu.csc.mas.ontology.Slot;
import edu.ncsu.csc.mas.ontology.exceptions.MalformedConditionException;
//import edu.ncsu.csc.mas.ontology.Constants;


/**
 * @author pchakra
 *
 */
public class Owlp2Jess {
	
		
    
    public static void main(String arguments[]) 
    throws MalformedConditionException,IOException
    {
        OwlpGenerator oF = OwlpGenerator.getOwlpGenerator() ;
        Vector ontProtocols = oF.generateProtocols() ;
        
        // choose the right protocol as a composite protocol ontology has 
        // multiple protocol individuals        
        Protocol prot=chooseProtocol(ontProtocols);           
        if(prot!=null)
        	System.out.print("Chosen protocol:"+prot.toString()) ;
        else
        	return;
        
        SkeletonGenerator skelGen = new SkeletonGenerator() ;
        
        
             
        FileWriter protocolRules = new FileWriter(prot.getInstName()+ ".clp");
        BufferedWriter out1 = new BufferedWriter(protocolRules);
   
        for(int i=0;i<prot.getRules().size();i++)
        {	
        	
        	out1.write(((Rule)prot.getRules().elementAt(i)).toString(prot));
        	
        	//System.out.println("Rule written:  "+ ((Rule)prot.getRules().elementAt(i)).toString(prot));
        }
        
         out1.close();
        
        if(prot.getRoles()!=null) {
            for(int i=0; i< prot.getRoles().size(); i++) {
            	Role role = (Role)(prot.getRoles().elementAt(i));
            	String clpFileName = role.getName() + ".clp";
            	String policyClpFileName = role.getName()+"Policies.clp";
        		FileWriter clpFile = new FileWriter(clpFileName);
        		BufferedWriter out2 = new BufferedWriter(clpFile);
        		FileWriter policyClpFile = new FileWriter(policyClpFileName);
        		BufferedWriter out3 = new BufferedWriter(policyClpFile);
        		 out2.write("(import edu.ncsu.csc.mas.protocols."+ prot.getInstName()+".messages.*)");
                 out2.write("\n(import edu.ncsu.csc.mas.enactments.JessJ2EE.*)");
                 out2.write("\n(import edu.ncsu.csc.mas.protocols."+ prot.getInstName()+"."+ role.getName()+".*)");
                 out2.write("\n (import edu.ncsu.csc.mas.utils.JMSWrapper)");
                 out2.write("\n(defclass startMsgProp start extends msg)");
                 
                 out3.write("(import edu.ncsu.csc.mas.protocols."+ prot.getInstName()+".messages.*)");
                 out3.write("\n(import edu.ncsu.csc.mas.enactments.JessJ2EE.*)\n");
                 

        		 Vector ruleVec = skelGen.generateSkeleton(prot,role) ;         
                      	 
               	 
               	 if(ruleVec==null)
                    continue;
                prot.setSkelRules(ruleVec, (Role)(prot.getRoles().elementAt(i))) ;
                
                
                for(int j=0; j<ruleVec.size(); j++) {
	                
                    Rule rule = (Rule)role.getSkelRules().elementAt(j);
                    int index=0;
                    String ruleName;
           		 if(rule.getName().indexOf("Rule") != -1)
                    index= rule.getName().indexOf("Rule");
                                
           		 else if(rule.getName().indexOf("_rule") != -1)
           				  index= rule.getName().indexOf("_rule");
           		         
           		ruleName = rule.getName().substring(0,index);
                   
                    out2.write("\n(defclass " + ruleName+ " "+ ruleName+ " extends msg)");
                    out2.write("\n(defclass " + ruleName+ "Msg "+ruleName+ " extends msg)");
                    out2.write("\n(defclass " + ruleName+ "MsgProp "+ruleName+ " extends msg)");
                
                    
                } 
                
                Vector policies = skelGen.getRolePolicies();
                System.out.println("\n\nPolicies here");
            
                for(int j=0; j<policies.size(); j++) {
	                
                    Policy policy = (Policy)(policies.elementAt(j));
                    System.out.println(policy.toString());
                    out2.write("\n(deftemplate " + policy.toDeftemplateString());

                } 
                
                out2.write("\n(defclass "+ role.getName()+ prot.getInstName()+"Policy " + role.getName()+ prot.getInstName()+"Policy)\n");
                
                for(int j=0; j<ruleVec.size(); j++) {
                	                
                    Rule rule = (Rule)role.getSkelRules().elementAt(j);
                    System.out.println("Printing rule for role "+ role + ": " + rule.toString(prot));
                   
                    out2.write(rule.toString(prot));
                   
                    out3.write(rule.generatePolicy(prot,role));
                                      
                    
                }
                out2.close();
                out3.close();
            }
        }
    }
    
    public static Protocol chooseProtocol(Vector ontProtocols) throws MalformedConditionException
    {
    	Protocol prot=null;
    	
    	if(ontProtocols.size()==1)
        	prot = new Protocol((OntResource)ontProtocols.get(0));
        else
        {
        	for(int i=0;i<ontProtocols.size();i++)
        	{
        		OntResource ontProt = (OntResource)ontProtocols.get(i);        		
        		StmtIterator sIter = ontProt.listProperties();
        		while(sIter.hasNext())
        		{
        			Statement st = sIter.nextStatement();
        			RDFNode objRDFNode = st.getObject() ;        			
                    
        			//try and convert this object into an OntResource
                    if(objRDFNode==null || !objRDFNode.canAs(OntResource.class))
                    	continue;
                    
                    if(st.getPredicate().getLocalName().equals(Constants.PROTOCOL_COMPOSITION_PROFILE_PROPERTY_NAME)) {
                        //the object we found was a role. Create a role for it
                        prot = new Protocol(ontProt);
                        return prot;
                    }
        		}
        	}        	
        }
        
        if(prot==null)
        	System.out.print("ERROR: Could not find a suitable protocol") ;        
        
        return prot;
    }

}
