/*
 * Created on Nov 1, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.ncsu.csc.mas.utils;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;

import com.hp.hpl.jena.ontology.OntResource;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;

import edu.ncsu.csc.mas.codeGen.ProtMsgCodeGen;
import edu.ncsu.csc.mas.codeGen.RoleMainCodeGen;
import edu.ncsu.csc.mas.codeGen.RolePolicyCodeGen;
import edu.ncsu.csc.mas.codeGen.StartMsgCodeGen;
import edu.ncsu.csc.mas.ontology.Message;
import edu.ncsu.csc.mas.ontology.Protocol;
import edu.ncsu.csc.mas.ontology.Role;
import edu.ncsu.csc.mas.ontology.exceptions.MalformedConditionException;
//import edu.ncsu.csc.mas.ontology.Constants;


/**
 * @author pchakra
 *
 */
public class OwlpCodeGenerator {

	    
	    public static void main(String arguments[]) 
	    throws MalformedConditionException,IOException
	    {
	        OwlpGenerator oF = OwlpGenerator.getOwlpGenerator() ;
	        Vector ontProtocols = oF.generateProtocols() ;
	        
	        // choose the right protocol as a composite protocol ontology has 
	        // multiple protocol individuals        
	        Protocol prot=chooseProtocol(ontProtocols);           
	        if(prot!=null)
	        	System.out.print("Chosen protocol:"+prot.toString()) ;
	        else
	        	return;
	        
	        SkeletonGenerator skelGen = new SkeletonGenerator() ;
	        File path = new File("edu" + File.separator + "ncsu" + File.separator + "csc" + File.separator + "mas" + File.separator
					+ "protocols" + File.separator + prot.getInstName() + File.separator + "messagesTemp");
	        path.mkdirs();       
	        for(int i=0;i<prot.getMessages().size();i++)
	        {
	        	Message msg= (Message)prot.getMessages().elementAt(i);
	        	System.out.println("ProtMessage: " + msg.toString());
	        	ProtMsgCodeGen pmcg = new ProtMsgCodeGen();
	        	//System.out.println("\n\n\n\n\n******New Class Template****\n\n");
	        	//System.out.println(pmcg.generate(prot.getMessages().elementAt(i), prot));
	        	File f= new File(path + File.separator +  msg.getType()+ ".java");
	        	FileWriter protMessages = new FileWriter(f.getAbsoluteFile());
	            BufferedWriter outMsg = new BufferedWriter(protMessages);
	            outMsg.write(pmcg.generate(prot.getMessages().elementAt(i), prot));
	        	outMsg.close();
	        	
	        	
	        }
	        File start= new File(path + File.separator +"start.java");
	    	FileWriter startMsg = new FileWriter(start.getAbsoluteFile());
	        BufferedWriter outStart = new BufferedWriter(startMsg);
	        StartMsgCodeGen smcg= new StartMsgCodeGen();
	        outStart.write( smcg.generate(prot));
	    	outStart.close();
	    	
	    	for(int i=0;i<prot.getRoles().size();i++)
	    	{
	    		Role role = (Role)prot.getRoles().elementAt(i);
	    		RoleMainCodeGen rmcg = new RoleMainCodeGen();
	    		//System.out.println(rmcg.generate(role, prot));
	    		File path2 = new File("edu" + File.separator + "ncsu" + File.separator + "csc" + File.separator + "mas" + File.separator
						+ "protocols" + File.separator + prot.getInstName() + File.separator + role.getName()+"Temp");
	    		path2.mkdirs();
	    		File fRole= new File(path2+ File.separator + "Main.java");
	        	FileWriter roleMain = new FileWriter(fRole.getAbsoluteFile());
	            BufferedWriter roleMainMsg = new BufferedWriter(roleMain);
	            roleMainMsg.write(rmcg.generate(role, prot));
	            roleMainMsg.close();
	            RolePolicyCodeGen rpcg = new RolePolicyCodeGen();
	    		System.out.println(rmcg.generate(role, prot));
	    		File fRolePolicy= new File(path2+ File.separator + role.getName()+ prot.getInstName()+ "Policy.java");
	        	FileWriter rolePolicy = new FileWriter(fRolePolicy.getAbsoluteFile());
	            BufferedWriter rolePolicyMsg = new BufferedWriter(rolePolicy);
	            System.out.println(rpcg.generate(role, prot));
	            rolePolicyMsg.write(rpcg.generate(role, prot));
	            rolePolicyMsg.close();
	    			
	    		
	    	}
	        
}
	    public static Protocol chooseProtocol(Vector ontProtocols) throws MalformedConditionException
	    {
	    	Protocol prot=null;
	    	
	    	if(ontProtocols.size()==1)
	        	prot = new Protocol((OntResource)ontProtocols.get(0));
	        else
	        {
	        	for(int i=0;i<ontProtocols.size();i++)
	        	{
	        		OntResource ontProt = (OntResource)ontProtocols.get(i);        		
	        		StmtIterator sIter = ontProt.listProperties();
	        		while(sIter.hasNext())
	        		{
	        			Statement st = sIter.nextStatement();
	        			RDFNode objRDFNode = st.getObject() ;        			
	                    
	        			//try and convert this object into an OntResource
	                    if(objRDFNode==null || !objRDFNode.canAs(OntResource.class))
	                    	continue;
	                    
	                    if(st.getPredicate().getLocalName().equals(Constants.PROTOCOL_COMPOSITION_PROFILE_PROPERTY_NAME)) {
	                        //the object we found was a role. Create a role for it
	                        prot = new Protocol(ontProt);
	                        return prot;
	                    }
	        		}
	        	}        	
	        }
	        
	        if(prot==null)
	        	System.out.print("ERROR: Could not find a suitable protocol") ;        
	        
	        return prot;
	    }
}
